//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "FastCrypt_unit.h"

void cripta();
void decifra();
void help();
void about();


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tf *f;

void cripta()
{
  AnsiString testo=f->input->Text;
  int n, lunghezza, key, newkey;
  n=0;
  key=(StrToInt(f->key1->Text));
  if((key<2) || (key>1024))
  {
        ShowMessage("Invalid Key");
        return;
  }
  key=key+5;
  newkey=key;
  lunghezza=testo.Length();

  while (n<lunghezza)
  {
    if ((n%2)==0)
      newkey=key-1;
    else
      newkey=key;
    testo[n+1]=testo[n+1]+newkey;
    n=n+1;
  }
  f->output->Text=testo;
}

//################

void decifra()
{
  AnsiString testo=f->output->Text;
  int n, lunghezza, key, newkey;
  n=0;
  key=StrToInt(f->key1->Text);
  if((key<2) || (key>1024))
  {
        ShowMessage("Invalid Key");
        return;
  };
  key=key+5;
  newkey=key;
  lunghezza=testo.Length();

  while (n<lunghezza)
  {
    if ((n%2)==0)
      newkey=key-1;
    else
      newkey=key;
    testo[n+1]=testo[n+1]-newkey;
    n=n+1;
  }

  f->input->Text=testo;
}

//###########

void help()
{
  ShowMessage("To encript, put some text in the first field,\n"
              "enter the key number (integer value between\n"
              "2 and 1024) and press the ENCRYPT button. Then\n"
              "check if the result if correct by performing\n"
              "a decode.\n\n"
              "To decode, put some text in the second field,\n"
              "then enter the key number and press the DECODE\n"
              "button.");
}

void about()
{
  ShowMessage("FastCrypt 1.0 by ** JaKe **\n"
                "          16/01/2007      \n"
                " http://www.jake-afc.net/ \n") ;
}
//---------------------------------------------------------------------------
__fastcall Tf::Tf(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall Tf::btn_cifraClick(TObject *Sender)
{
        cripta();
}
//---------------------------------------------------------------------------

void __fastcall Tf::btn_decifraClick(TObject *Sender)
{
        decifra();
}
//---------------------------------------------------------------------------

void __fastcall Tf::btn_helpClick(TObject *Sender)
{
  help();
}
//---------------------------------------------------------------------------

void __fastcall Tf::btn_aboutClick(TObject *Sender)
{
  about();
}
//---------------------------------------------------------------------------


